<?php
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
# display source of script if requested so
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
$pageName	= 'configure_now.php';
$version_string	= '0.00 ';
$pageVersion	= $version_string.'2016-01-23';
#
if (!isset($SITE)){echo "<h3>invalid call to script $pageName</h3>";exit;}
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
ws_message (   '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile].' -->');
$my     =  basename(__FILE__);
#-----------------------------------------------------------------------
# 0.00 2016-01-23	first version with 2.6/7/8 support
#
# Adding    p=0001&pw=xxxx willl bring a window to change some settings for a max 24 ht period
# ----------------------------------------------------------------------
# for use with pre 2.8 release
if (!function_exists ('ws_message') ) {
    function ws_message ($message,$always=false) {
	global $wsDebug, $SITE;
	$echo	= $always;
	if ( $echo == false && isset ($wsDebug) && $wsDebug == true ) 			{$echo = true;}
	if ( $echo == false && isset ($SIE['wsDebug']) && $SIE['wsDebug'] == true ) 	{$echo = true;}
	if ( $echo == true ) {echo $message.PHP_EOL;}
    }
}
#
$cachefile	= $SITE['cacheDir'].'_configure_now.arr';
# ----------------------------------------------------------------------
# script started by menu choice so password is needed
#
ws_message (  '<!-- '.$my.' ('.__LINE__.'): Checking pw -->');
if (!isset ($SITE['password']) || $SITE['password'] == '') { # Password should be set  in wsUserSettings and used for using this facility 
        echo '<h3 style="text-align: center; margin: 20px auto;">Error '.$my.' ('.__LINE__.') Needs password protection</h3>';
        return;
}
#
$wp     = $SITE["WXsoftware"];
$region = $SITE["region"];
#
# load all texts / langlookup a.s.o.
$css = $settings_now = '';
configure_now_strings();
#
list ($script) 	= explode ('.',$pageFile);
if (isset ($SITE['pages'][$script]) ) {$form_action = $SITE['pages'][$script];} else {$form_action = 'index.php?p=0001';} // should never happen ! 
$form_action    .= '&amp;pw='.$SITE['password'];		
#
#
# check if there is a post request
if (isset ($_POST['config_now']) ) {
        if ($_REQUEST['pw'] <> $SITE['password'] ) {    # Invalid password used 
                echo '<h3 style="text-align: center; margin: 20px auto;">Error '.$my.' ('.__LINE__.') </h3>';
                return;
        }
        $string = '<?php # emergency settings from '.date ($SITE["timeFormat"]).PHP_EOL; 
        if (isset ($_POST['config_now']['config_delete']) ) {
                $SITE["_emergency"] = "removed";
                $result = unlink($cachefile);
                ws_message (  '<!-- '.$my.' ('.__LINE__.'): removing '.$cachefile.' return code = '.$result.' -->');
                echo '<h3 style="text-align: center; margin: 20px auto;">Temporary settings file invalidated.</h3>';	
                return;
        }
# we have to save the answers given
# echo '<pre>'.print_r($_POST['config_now'],true).'</pre>'.PHP_EOL;
        $allowed        = array ('curCondFrom','maintenanceShow','maintenanceTxt','bannerTop','bannerTopTxt','colorNumber','fctOrg','warnings');
	foreach ($_POST['config_now'] as $setting => $value) {
	        if (!in_array ($setting,$allowed) ) {
	                ws_message (  '<!-- '.$my.' ('.__LINE__.'): post value '.$setting.' skipped - unknown -->');	
	                continue;
	        } 
	        $string .= '$SITE["'.$setting.'"] = '; 
	        if ($value == 'true' || $value == 'false') { $quote='';} else { $quote='"';}
	        $string .= $quote.$value.$quote.';'.PHP_EOL;
	} // eo foreach post
# clean up end script
        $string .= '$SITE["_emergency"] = "used";'.PHP_EOL; 
        $result = file_put_contents ($cachefile,$string);
        ws_message (  '<!-- '.$my.' ('.__LINE__.'): writing '.$cachefile.' return code = '.$result.' -->');
        echo '<h3 style="text-align: center; margin: 20px auto;">Temporary settings file created.</h3>';	
        return; 	
} // eo check post-request
# ----------------------------------------------------------------------
echo '<div class="blockDiv" style="">
<h3 class="blockHead">'.langtransstr('conf-pagetitle').'</h3>'.PHP_EOL;
echo $css; 
unset ($css);
#
$arr	        = explode  ("\n", $settings_now);       #  echo '<pre>'.print_r($arr,true).'</pre>'.PHP_EOL;
$end_arr	= count ($arr);
for ($n = 0; $n < $end_arr; $n++) {
        $line	= $arr[$n];
        if (substr($line,0,1)  <> '|') {continue;}
        $items	= explode ('|', $line);		// extra | so that the numbers are 1,2,3,4  
# echo '<pre>';  print_r($items); exit;	
        if (!is_numeric ($items[1]) ) {
                ws_message (  '<!-- '.$my.' ('.__LINE__.'): settings text line '.$n.' skipped - nr not numeric -->');	
                continue;
        }
        $nr		= $items[1];
        $text		= trim($items[2]);
        $set_wp		= $text;
        $set_region	= trim($items[3]);
        if (!isset ($items[4]) ) {
                echo $start_echo.'Error in line '.$line.$end_echo; continue;
                ws_message (  '<!-- '.$my.' ('.__LINE__.'): Error in line '.$line.' -->');
        }
        $set_key	= trim($items[4]);
        $set_type	= trim($items[5]);
        $set_old	= trim($items[6]);        
        $set_new        = '';
        if (isset ($SITE[$set_key]) ) {
                $value  = $SITE[$set_key];
                if      ($value === true)  { $value = 'true';}
                elseif  ($value === false) { $value = 'false';}
                $set_new = $value;
        }
        if (!isset ($items[7]) ) 
             {  $set_values 	= ''; }
        else {	$set_values	= trim($items[7]);}
        $settings [$nr][$n] = array ('wp' => $set_wp,'region' => $set_region,'setting' => $set_key,'type' => $set_type, 'new' => $set_new,'old' => $set_old ,'values' => $set_values);		
} // eo for each line
# there is only 1 set of questions so load this set
$form = $settings['00'];
# print the questions
#
echo '<div id="config__manager">
<form action="'.$form_action.'&amp;lang='.$lang.'&amp;show=missing#data-area" method="post">
<table class="inline">
';
#
foreach ($form as $key => $arr) { 
        tr_setting($key, $arr);
}
echo '
<tr class="headerline1"><td>&nbsp;</td><td class="headerline1" style="color: red;">Password => wsUserSettings.php</td></tr>
<tr class="">
      <td class="label" style="color: red;">Password => wsUserSettings.php</td>
      <td class="value">
	<div class="input ">
          <input id="pw" name="pw" type="text" class="edit" value="">
        </div>
      </td>
</tr>
</table>
<p style="float: right;">
  <input type="submit" name="config_now[submit]"        class="button" 	value="'.langtransstr('Save').'">
  <input type="submit" name="config_now[config_delete]" class="button" 	value="'.langtransstr('Delete').'">
  
</p>
<br /><br /><br />
</form>
</div>
</div>';
return;
  // eo display normal group
function tr_setting($key, $arr) {
	global  $wp, $region;
	if ($arr['wp'] 	   <> '--' && $arr['wp']     <> $wp) 	// skip lines for other weatherprogram	
		{return;} 
	if ($arr['region'] <> '--' && $arr['region'] <> $region)// skip lines for other region	
		{return;}
	if ($arr['type'] == 'none') 				// skip no use lines
		{return;}					
	if ($arr['type'] == '##') {
		echo '
	<tr class="headerline2"><td class="headerline2" colspan="2">'.langtransstr($arr['old']).'</td></tr>';	
		return;
	}
	if ($arr['type'] == '#') {
		echo '
	<tr class="headerline1"><td>&nbsp;</td><td class="headerline1">'.langtransstr($arr['old']).'</td></tr>';	
		return;
	}
	$border         = $error = '';
	$setting	= $arr['setting'];
	$text		= 'conf-'.trim($setting);
	$link		= 'link-'.trim($setting);
	$text_trans     = langtransstr($text);
	if ($text == $text_trans) {$text_trans = 'explain text for '.$setting.' will be added shortly';}

	$field_type	= $field_typeXX	= $arr['type'];
	$value		= $arr['new'];
	$value_old	= $arr['old'];
	$field_type	= str_replace ('region','',$field_typeXX);
	if ($field_type <> $field_typeXX) {
		$field_type	= lcfirst($field_type);
		$arrOld	= explode ('!',$value_old.'!');
		foreach ($arrOld as $keyOld => $val_regOld) {
			list ($value_old, $regionOld) 	= explode ('#',$val_regOld.'#');	
			if (($regionOld == $region) || ($regionOld == '')  || ($regionOld == 'all') || ($regionOld == '--')  ) {break;}
		} // eo foreach 
	} 
	if  	( ($value_old == 'true') && ($value === true) )	{$value = $value_old;} 
	elseif  ( ($value_old == 'false')&& ($value === false)) {$value = $value_old;}
	$class = '';
	if 	($value == '')		{$value	= $value_old; $class = 'default';} 
	$values		= $arr['values'];
	echo '
    <tr class="">
      <td class="label">'.$text_trans.'</td>
      <td class="value" '.$border.'><span class="outkey">'.$setting.'</span>';
# ----------------------------      
	if ($field_type == 'select') {
		echo '
        <div class="input '.$class.'" ><!-- '.$field_type.' with value = '.$value. ' -->
	  <select class="edit  '.$class.'" id="config__'.$key.'" name="config_now['.$setting.']">';
		$arr_values 	= explode ('!',$values);
		foreach ($arr_values as $none => $string) {
			list ($short,$long,$optional) = explode ('#',$string.'#');
			$optional	= trim($optional);
			if ($optional <> '') {
				$ok = array($region, 'all', '--');
				if (!in_array ($optional, $ok ) ) {continue;}
			}
			if ($value == $short) {$selected = 'selected="selected"';} else {$selected = '';}
			$long	= langtransstr($long);
			echo '
	     <option value="'.$short.'" '.$selected.'>'.$long.'</option>';
		}
            	echo '
          </select>  
        </div>';
	}
# ----------------------------
	elseif (  $field_type  == 'htmltext' || $field_type == 'numberDecimal'  ||
		  $field_type  == 'allcap'  ) {
		echo '
	<div class="input '.$class.'"><!-- '.$field_type.' with value = '.$value. ' -->
          <input id="config__'.$key.'" name="config_now['.$setting.']" type="text" class="edit" value="'.$value.'">
        </div>';
        }
# ----------------------------
	else {	echo ' 
 	<div class="input '.$class.'"><!-- '.$field_type.' with value = '.$value. ' -->
          <input id="config__'.$key.'" name="config_now['.$setting.']" type="text" class="edit" value="INVALID FIELDTYPE '.$field_type.' - '.$value.'">
        </div>';
        } // eo if list
	if ($error <> '') {echo $error;}    
	echo '
      </td>
    </tr>';
}
#
function configure_now_strings() {
        global $css, $settings_now, $LANGLOOKUP, $SITE;
        $settings_now = <<<EOT
#---------------------------------------------------------------------------------------|	
#nr|wp	|region	|key		|type 		|old/default	|values allowed		|
#---------------------------------------------------------------------------------------|
|00|--	|--	|--		|#		|conf-curCondFrom_hd||
|00|--	|--	|curCondFrom	|select		|yahoo		|yahoo#Yahoo - needs area code!metar#metar - uses your nearby metar!wd#WeatherDisplay if it has a solar sensor and is configured correctly|

|00|--	|--	|--		|#		|conf-maintenanceShow_hd|
|00|--	|--	|maintenanceShow|select		|true		|true#Display the yellow box on top of the page!false#Do not use|
|00|--	|--	|maintenanceTxt	|htmltext	|./_my_texts/maintenance.txt|		|

|00|--	|--	|--		|#		|conf-bannerTop_hd|	|
|00|--	|--	|bannerTop	|select		|true		|true#use my text file!false#Do not display|
|00|--	|--	|bannerTopTxt	|htmltext	|./_my_texts/banner.txt|		|

|00|--	|--	|--		|#		|conf-colorNumber_hd|	|
|00|--	|--	|colorNumber	|select		|0		|0#weather_adapted!1#green!2#blue!3#pastel!4#red!5#orange!6#none!7#ws_clouds!8#ws_cloudsn!9#ws_mist!10#ws_moon!11#ws_pclouds!12#ws_rain!13#ws_snow!14#ws_storm!15#ws_sun!16#ws_thunder|

|00|--	|--	|--		|#		|conf-fctOrg_hd|	|
|00|--	|--	|fctOrg		|regionSelect	|ec#canada!noaa#america!metno#europe!metno#other|yahoo#Yahoo - needs area code#all!wu#WeatherUnderground - needs key#all!wxsim#WXSIM needs extra program#all!yrno#Yrno needs area code#all!metno#MetNo#all!yowindow#YoWindow gadget#all!noaa#NOAA#america!ec#Environment Canada#canada!hwa#Het Weer Actueel - alleen voor leden#europe|

|00|--	|--	|--		|#		|conf-warnings_hd||
|00|--	|--	|warnings	|select		|false		|true#Use the weatherwarnings for your area!false#Do not display|

EOT;

        $css = '
<style scoped>
/* version 0.00   2016-06-23 */
#config__manager .headerline2 td {
	text-align: center;
	border: 0px solid #ccc;
	font-weight: bold;
	font-size: 1.17em;
	padding-bottom: 5px;
	padding-top: 0px;
}
#config__manager .headerline1 td {
	text-align: left;
	border: 1px solid #ccc;
	font-weight: bold;
	font-size: 1.0em;
	padding-bottom: 5px;
	padding-top: 5px;
	background-color: #ccc;
}
#config__manager a.urlextern {
	background-image: url(globe.png);
	background-repeat: no-repeat;
	background-position: 0 center;
  	background-position-x: 0px;
  	background-position-y: 50%;
  	padding: 0 0 0 18px;
}
#config__manager .headerline tr {
	text-align: center;
	border: 0px solid #ccc;
}

#config__manager {
  background-color: #eee;
  padding: 10px;
/*  max-width: 800px; */
  border: 1px solid #ccc;
  margin: 0 auto;
}
#config__manager table {
  border-collapse: collapse;
  empty-cells: show;
  border-spacing: 0;
  border: 0px solid #ccc;
  width: 100%;
  margin-bottom: 10px;
}
#config__manager button {
	margin-bottom: 5px;
}
#config__manager td {
  border: 1px solid #ccc;
  padding: .3em .5em;
  vertical-align: top;
}
#config__manager label {
}
#config__manager td.label {
  padding: .1em 0.2em .1em 1em;
  vertical-align: middle;
  text-align: right;
}
#config__manager td.value {
    width: 31em; 
}
#config__manager select.default { 
    background-color: #cdf;
}
#config__manager div.input  {
	margin: 0.8em;
}
#config__manager div.default input.edit {
	background-color: #cdf;
}
#config__manager input div.default.edit {
	background-color: #cdf;
}
#config__manager div.default, span.default, div.default.edit{
	background-color: #cdf;
	min-width: 20em;
}
#config__manager td input.edit {
  width: 36em;
}

#config__manager td.value span.outkey{
  font-size: 70%;
  margin-top: -0.7em;
  margin-right: 2em;
  margin-bottom: 0.5em;
  display: block;
  background-color: #fff;
  color: #666;
  float: left;
  padding: 0 .1em;
  position: relative;
  z-index: 1;
}
</style>'.PHP_EOL;

        $lang   = $SITE['lang'];
        if ($lang == 'en') {
                $LANGLOOKUP['conf-pagetitle']           = 'Change some settings temporarily';
                $LANGLOOKUP['conf-curCondFrom_hd']      = 'Where to load the current conditions from';
                $LANGLOOKUP['conf-curCondFrom']	        = 'Select the source to get the current conditions from.';

                $LANGLOOKUP['conf-maintenanceShow_hd']	= 'The  yellow box at the top';
                $LANGLOOKUP['conf-maintenanceShow']	= 'The yellow box can be shown or hidden using this setting.';
                $LANGLOOKUP['conf-maintenanceTxt']	= 'Use this yellow box for a warning that certain pages are temporarily disabled because of certain problems or maintenance.';

                $LANGLOOKUP['conf-bannerTop_hd']        = 'You can use different banners to warn visitors about changes / problems also.';		
                $LANGLOOKUP['conf-bannerTop']		= 'Top of the page banner';
                $LANGLOOKUP['conf-bannerTopTxt']	= 'Use this file or type the location of another file';

                $LANGLOOKUP['conf-colorNumber_hd']      = 'Switch to another color scheme';
                $LANGLOOKUP['conf-colorNumber']         = 'Currently set color scheme';

                $LANGLOOKUP['conf-fctOrg_hd']           = 'Which forecast will be used on the start-page';
                $LANGLOOKUP['conf-fctOrg'] 		= 'Select the default forecast which will be avilable on the </b>start-page</b>.';

                $LANGLOOKUP['conf-warnings_hd']         = 'Show (optional) meteo warnings on every page.';
                $LANGLOOKUP['conf-warnings']		= 'Switch off by problems..';
        }
        elseif ($lang == 'nl') {
                $LANGLOOKUP['conf-pagetitle']           = 'Pas 1 of meer settings tijdelijk aan ';
                $LANGLOOKUP['conf-curCondFrom_hd']      = 'Van waar worden de "huidige weer-condities" opgehaald';
                $LANGLOOKUP['conf-curCondFrom']	        = 'Selecteer hier.';
                $LANGLOOKUP['conf-maintenanceShow_hd']	= 'Het gele vak helemaal bovenaan de pagina';
                $LANGLOOKUP['conf-maintenanceShow']	= 'Zet het tonen van het vak hier aan of uit';
                $LANGLOOKUP['conf-maintenanceTxt']	= 'Gebruik dit tekstbestand of type de naam van een ander bestand';
                $LANGLOOKUP['conf-bannerTop_hd']        = 'Gebruik een banner om een mededeling te doen';		
                $LANGLOOKUP['conf-bannerTop']		= 'Selecteer hier of u een banner wil tonen';
                $LANGLOOKUP['conf-bannerTopTxt']	= 'Gebruik dit tekstbestand of type de naam van een ander bestand.';
                $LANGLOOKUP['conf-colorNumber_hd']      = 'Gebruik tijdelijk een ander kleurenschema';
                $LANGLOOKUP['conf-colorNumber']         = 'Het huidige schema kunt u hier aanpassen';
                $LANGLOOKUP['conf-fctOrg_hd']           = 'Gebruik een andere standaard weers-verwachting';
                $LANGLOOKUP['conf-fctOrg'] 		= 'Selecteer hier de tegebruiken waars-verwachting voor de </b>start-pagina</b>.';
                $LANGLOOKUP['conf-warnings_hd']                 = 'Pas de gebruikte weer-waarschuwingen aan';
                $LANGLOOKUP['conf-warnings']		        = 'Switch off by problems';
                $LANGLOOKUP['Yahoo - needs area code']          ='Yahoo - u moet een gebiedscode ingesteld hebben';
                $LANGLOOKUP['metar - uses your nearby metar']	= 'metar - gebruikt uw latitude/longitude';
                $LANGLOOKUP['WeatherDisplay if it has a solar sensor and is configured correctly']	= 'WeatherDisplay alleen als u een solar sensor heeft en WD juist is ingesteld';
                $LANGLOOKUP['Display the yellow box on top of the page']	= 'Gebruik het gele vak';
                $LANGLOOKUP['Do not use']	                = 'Gebruik niet';
                $LANGLOOKUP['use my text file']	                = 'Gebruik de banner';
                $LANGLOOKUP['Do not display']	                = 'Gebruik niet';
                $LANGLOOKUP['WeatherUnderground - needs key']	= 'WeatherUnderground - heeft een API key nodig';
                $LANGLOOKUP['WXSIM needs extra program']	= 'WXSIM dit is een extra programma';
                $LANGLOOKUP['Yrno needs area code']	        = 'Yrno - u moet een gebiedscode ingesteld hebben';
                $LANGLOOKUP['MetNo']	                        = 'MetNo - gebruikt uw latitude/longitude';
                $LANGLOOKUP['Use the weatherwarnings for your area']	= 'Gebruik de weerwaarschuwingen voor het door u ingestelde gebied';
                $LANGLOOKUP['Save']	                        = 'Bewaar';
        }        
        else {  $LANGLOOKUP['conf-pagetitle']           = 'Change some settings temporarily';
                $LANGLOOKUP['conf-curCondFrom_hd']      = 'Where to load the current conditions from';
                $LANGLOOKUP['conf-curCondFrom']	        = 'Select the source to get the current conditions from.';

                $LANGLOOKUP['conf-maintenanceShow_hd']	= 'The  yellow box at the top';
                $LANGLOOKUP['conf-maintenanceShow']	= 'The yellow box can be shown or hidden using this setting.';
                $LANGLOOKUP['conf-maintenanceTxt']	= 'Use this yellow box for a warning that certain pages are temporarily disabled because of certain problems or maintenance.';

                $LANGLOOKUP['conf-bannerTop_hd']        = 'You can use different banners to warn visitors about changes / problems also.';		
                $LANGLOOKUP['conf-bannerTop']		= 'Top of the page banner';
                $LANGLOOKUP['conf-bannerTopTxt']	= 'Use this file or type the location of another file';

                $LANGLOOKUP['conf-colorNumber_hd']      = 'Switch to another color scheme';
                $LANGLOOKUP['conf-colorNumber']         = 'Currently set color scheme';

                $LANGLOOKUP['conf-fctOrg_hd']           = 'Which forecast will be used on the start-page';
                $LANGLOOKUP['conf-fctOrg'] 		= 'Select the default forecast which will be avilable on the </b>start-page</b>.';

                $LANGLOOKUP['conf-warnings_hd']         = 'Show (optional) meteo warnings on every page.';
                $LANGLOOKUP['conf-warnings']		= 'Zet uit bij problemen';     
                   
 		$LANGLOOKUP['Yahoo - needs area code']  = 'Yahoo - needs area code';
		$LANGLOOKUP['metar - uses your nearby metar']           = 'metar - uses your nearby metar';
		$LANGLOOKUP['WeatherDisplay if it has a solar sensor and is configured correctly']   = 'WeatherDisplay if it has a solar sensor and is configured correctly';
		$LANGLOOKUP['Display the yellow box on top of the page']= 'Display the yellow box on top of the page';
		$LANGLOOKUP['Do not use']               = 'Do not use';
		$LANGLOOKUP['use my text file']         = 'use my text file';
		$LANGLOOKUP['Do not display']           = 'Do not display';
		$LANGLOOKUP['WeatherUnderground - needs key']   = 'WeatherUnderground - needs key';
		$LANGLOOKUP['WXSIM needs extra program']        = 'WXSIM needs extra program';
		$LANGLOOKUP['Yrno needs area code']             = 'Yrno needs area code';
		$LANGLOOKUP['MetNo']                            = 'MetNo';
		$LANGLOOKUP['YoWindow gadget']                  = 'YoWindow gadget';
		$LANGLOOKUP['Use the weatherwarnings for your area']           = 'Use the weatherwarnings for your area';
		$LANGLOOKUP['Save']                     = 'Save';
        }  // eo language texts

} // eo load texts
# ----------------------  version history
# 0.02 2015-09-07 release 2.8 version 
